
local Message
do
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:SetFrameStrata("HIGH")
	frame:SetPoint("CENTER", 0, 200)
	frame:SetWidth(UIParent:GetWidth())
	frame:SetHeight(120)

	local fs = frame:CreateFontString(nil, "OVERLAY", "SystemFont_OutlineThick_WTF")
	fs:SetPoint("CENTER")
	fs:SetTextColor(1, 0.82, 0, 1)

	local anim = frame:CreateAnimationGroup()
	anim:SetScript("OnPlay", function() frame:Show() end)
	anim:SetScript("OnFinished", function() frame:Hide() end)

	local fade = anim:CreateAnimation("Alpha")
	fade:SetChange(-1)
	fade:SetDuration(0.5)
	fade:SetStartDelay(2)

	function Message(text)
		anim:Stop()
		fs:SetText(text)
		anim:Play()
	end
end

local seen = {}
local f = CreateFrame("Frame")
f:SetScript("OnEvent", function(self, event, instanceID)
	if event == "ZONE_CHANGED_NEW_AREA" then
		wipe(seen)
	elseif event == "VIGNETTE_ADDED" then
		local _, _, name, icon = C_Vignettes.GetVignetteInfoFromInstanceID(instanceID)
		if icon == 40 then return end -- not a chest

		if seen[instanceID] then return end
		seen[instanceID] = true

		PlaySoundFile([[Interface\AddOns\BabiiSkulls\KittenMeow.ogg]], "master")
		Message(("OMG RARE! %s"):format(name or ""))
	end
end)
f:RegisterEvent("VIGNETTE_ADDED")
f:RegisterEvent("ZONE_CHANGED_NEW_AREA")

